; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
; Simple Tab Control without Resource file. Author: William F Cravener 9/14/2011
; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	.586                      ; create 32 bit code
	.model flat, stdcall      ; 32 bit memory model
	option casemap :none      ; case sensitive

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	include \masm32\include\windows.inc
	include \masm32\include\gdi32.inc
	include \masm32\include\user32.inc
	include \masm32\include\kernel32.inc
	include \masm32\include\comctl32.inc
	include \masm32\include\masm32.inc

	includelib gdi32.lib
	includelib user32.lib
	includelib kernel32.lib
	includelib comctl32.lib
	includelib \masm32\lib\masm32.lib

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

	WinMain          PROTO :DWORD,:DWORD,:DWORD,:DWORD
	WndProc          PROTO :DWORD,:DWORD,:DWORD,:DWORD
	TabControls      PROTO :DWORD
	ShowTabIndex     PROTO :DWORD
	TopXY            PROTO :DWORD,:DWORD

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	FRECT	STRUCT
		min POINT <>
		max POINT <>
	FRECT ENDS
	
	TABCTRL equ 100


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
aGetClipboardText PROTO :DWORD,:DWORD
EcrireFinRichedit PROTO :DWORD
IDM_PASTE equ 3254
.data
	hInstance       dd 0
	hWnd            dd 0
	hDC             dd 0
	hTab            dd 0
	tabID1          dd 0
	tabID2          dd 0
	tabID3          dd 0
	tabCount        dd 0
	Hedit dd 0
	edit db "EDIT",0



	szYouPicked     db "You picked:",0
	szTabTitle1     db "Edit",0
	szTabTitle2     db "RichEdit",0

	szClassName     db "TABSEXAMPLE",0
	szDisplayName   db "Test Clipboard",0
	szButtonClass   db "BUTTON",0
	szWndClsTab     db "SysTabControl32",0
	szWhichTab      db "Tab Index Number:  ",0

	tie             TC_ITEM <>
	ps              PAINTSTRUCT <>
	icex            INITCOMMONCONTROLSEX <>
	RichEdDLL      db  'riched32.dll',0		;version 3 pour XP RichEdit44.dll	
	Hredit dd 0
	crichedit	DB 'RichEdit20A',0	
	Hreditdll dd 0
	mainmenu db "MAINMENU",0
	BufClipboard db 800h dup (0)

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

.code

start:
	invoke GetModuleHandle,0
	mov hInstance,eax
	invoke LoadLibrary, addr RichEdDLL
	mov     Hreditdll,eax
	
	mov icex.dwSize,sizeof INITCOMMONCONTROLSEX
	mov icex.dwICC,ICC_TAB_CLASSES
	invoke InitCommonControlsEx,ADDR icex
	invoke WinMain,hInstance,0,0,0
	invoke FreeLibrary,Hreditdll
	invoke ExitProcess,eax

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

WinMain proc hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

	; ===============================
	; Standard window creation stuff
	; ===============================

	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL Wwd:DWORD
	LOCAL Wht:DWORD
	LOCAL Wtx:DWORD
	LOCAL Wty:DWORD

	mov wc.cbSize,sizeof WNDCLASSEX
	mov wc.style,CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	mov wc.lpfnWndProc,OFFSET WndProc
	mov wc.cbClsExtra,0
	mov wc.cbWndExtra,0
	mov eax,hInst
	mov wc.hInstance,eax
	mov wc.hbrBackground,COLOR_WINDOW+1
	mov wc.lpszMenuName,OFFSET mainmenu
	mov wc.lpszClassName,OFFSET szClassName
	mov wc.hIcon,0 
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	mov wc.hIconSm,0

	invoke RegisterClassEx,ADDR wc

	mov Wwd,500
	mov Wht,400
	invoke GetSystemMetrics,SM_CXSCREEN
	invoke TopXY,Wwd,eax
	mov Wtx,eax
	invoke GetSystemMetrics,SM_CYSCREEN
	invoke TopXY,Wht,eax
	mov Wty,eax

	invoke CreateWindowEx,WS_EX_LEFT,ADDR szClassName,ADDR szDisplayName,
			WS_OVERLAPPEDWINDOW,Wtx,Wty,Wwd,Wht,0,0,hInstance,0

	mov hWnd,eax
	invoke ShowWindow,hWnd,SW_SHOW

	StartLoop:
	invoke GetMessage,ADDR msg,0,0,0
	cmp eax,0
	je ExitLoop
	invoke TranslateMessage,ADDR msg
	invoke DispatchMessage,ADDR msg
	jmp StartLoop
	ExitLoop:
	
	mov eax,msg.wParam 
	ret

WinMain endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

WndProc proc hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		local rect:FRECT

	.if uMsg == WM_CREATE
	; ==============================
	; Create our tab control window 
	; ==============================
	invoke GetClientRect,hWin,addr rect
		
	invoke CreateWindowEx,0,ADDR szWndClsTab,0,WS_VISIBLE or WS_CHILD or TCS_FIXEDWIDTH or TCS_BOTTOM,
				0,0,rect.max.x,300,hWin,TABCTRL,hInstance,0
	mov hTab,eax

	; ==============================
	; Create our first tab 
	; ==============================
	mov tie.imask,TCIF_TEXT
	mov eax,OFFSET szTabTitle1
	mov tie.pszText,eax
	invoke SendMessage,hTab,TCM_GETITEMCOUNT,0,0
	mov tabCount,eax
	invoke SendMessage,hTab,TCM_INSERTITEM,tabCount,ADDR tie
	mov 	tabID1,eax			
	invoke GetClientRect,hTab,addr rect
	mov eax,rect.max.y
	sub eax,30
	mov rect.max.y,eax
	;creer la boite d'edition
	invoke CreateWindowEx,WS_EX_OVERLAPPEDWINDOW or WS_EX_LTRREADING,addr edit,NULL,\
	WS_CHILD+WS_VISIBLE+ES_MULTILINE+ES_AUTOHSCROLL+ES_AUTOVSCROLL+WS_HSCROLL + WS_VSCROLL,\
		0,0,rect.max.x,rect.max.y,hTab,NULL,hInstance,NULL
	mov Hedit,eax			

	;--------------- Richedit ---------------------
	INVOKE     CreateWindowEx, NULL, addr crichedit, NULL,\
		WS_CHILD or WS_BORDER or ES_MULTILINE or \
		ES_NOHIDESEL or ES_SAVESEL or ES_SELECTIONBAR or\
		WS_HSCROLL or ES_AUTOHSCROLL or\
		WS_VSCROLL or ES_AUTOVSCROLL or WS_CLIPSIBLINGS or WS_CLIPCHILDREN,\
		0,0,rect.max.x,rect.max.y,hTab,NULL, hInstance, NULL
	mov Hredit,eax	
	
	
	

	; ==============================
	; Create our second tab 
	; ==============================
	mov tie.imask,TCIF_TEXT
	mov eax,OFFSET szTabTitle2
	mov tie.pszText,eax
	invoke SendMessage,hTab,TCM_GETITEMCOUNT,0,0
	mov tabCount,eax
	invoke SendMessage,hTab,TCM_INSERTITEM,tabCount,ADDR tie
	mov tabID2,eax


	; =====================================
	; Create all our tab button controls
	; =====================================
	

	.elseif uMsg == WM_COMMAND
		
		.if wParam == IDM_PASTE
		
			;INVOKE     SendMessage, Hredit, WM_PASTE, 0 ,0  ;coller
			invoke aGetClipboardText,addr BufClipboard,sizeof BufClipboard
			.if eax == 1
					invoke EcrireFinRichedit,addr BufClipboard
				;################################################################
			.endif
		.endif	

	.elseif uMsg == WM_NOTIFY
		; ==============================================
		; WM_NOTIFY is sent if a user clicks on a tab
		; Show/Hide the appropriate tab button controls
		; ==============================================
		mov eax,lParam
		mov eax,(NMHDR PTR [eax]).code
		.if eax == TCN_SELCHANGE
			invoke  SendMessage,hTab,TCM_GETCURSEL,0,0
			.if eax == tabID1
				invoke ShowWindow,Hedit,SW_SHOW
				invoke ShowWindow,Hredit,SW_HIDE
			.elseif eax == tabID2
				invoke ShowWindow,Hedit,SW_HIDE
				invoke ShowWindow,Hredit,SW_SHOWNORMAL				
			.endif 
		invoke ShowTabIndex,hWin
		.endif

	.elseif uMsg==WM_PAINT
		invoke BeginPaint,hWin,ADDR ps
		invoke ShowTabIndex,hWin
		invoke EndPaint,hWin,ADDR ps

	.elseif uMsg == WM_DESTROY
		invoke PostQuitMessage,0

	.endif

	invoke DefWindowProc,hWin,uMsg,wParam,lParam

	ret

WndProc endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
aGetClipboardText proc uses esi edi lpszBuffer:dword,taille:dword
	LOCAL hMemObj:dword,dwMemLen,hMemPtr,retour
	
	mov retour,0
	invoke IsClipboardFormatAvailable,CF_TEXT
	.if (eax)
		invoke OpenClipboard, NULL
		.if (eax)
			invoke GetClipboardData, CF_TEXT
			.if (eax)
				mov hMemObj, eax
				invoke GlobalSize, hMemObj
				mov dwMemLen, eax
				invoke GlobalLock, hMemObj
				mov hMemPtr, eax
				mov esi,hMemPtr
				mov edi,lpszBuffer
				mov ecx,dwMemLen
				.if ecx <= taille
					rep movsb
					mov retour,1
				.endif				
				invoke GlobalUnlock, hMemObj
			.endif
			invoke CloseClipboard
		.endif
	.endif
	ret
aGetClipboardText endp
EcrireFinRichedit PROC  pphrase:DWORD 
			LOCAL   charrange:CHARRANGE
			Local  retour:DWORD
	mov retour,1
		mov charrange.cpMin,-1
		mov charrange.cpMax,-1
		invoke SendMessage,Hredit,EM_EXSETSEL,0,addr charrange ;en fin de texte
		invoke SendMessage,Hredit, EM_REPLACESEL,0,pphrase	
FindeEcrireFinRichedit:
	mov eax,retour
	ret
EcrireFinRichedit endp	


; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

ShowTabIndex proc hWin:DWORD
	; ============================================
	; Display which tab index is currently active
	; ============================================
	invoke GetWindowDC,hWin
	mov hDC,eax
	invoke SendMessage,hTab,TCM_GETCURSEL,0,0
	invoke dwtoa,eax,OFFSET [szWhichTab+18] 
	invoke TextOut,hDC,110,350,ADDR szWhichTab,19
	invoke ReleaseDC,hWin,hDC

	ret

ShowTabIndex endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

TopXY proc wDim:DWORD, sDim:DWORD
	; ==============================================
	; Centers our tab control window on the desktop
	; ==============================================
	shr sDim,1
	shr wDim,1
	mov eax,wDim
	sub sDim,eax
	mov eax,sDim

	ret

TopXY endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

end start

